#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>

void find(int idx, uint64_t r2, uint64_t expected)
{
#pragma omp parallel for
    for (uint64_t i=0; i<0x100000000; i++) {
        uint64_t r1, r3, r4;
        r4 = i;
        r1 = i * i;
        r3 = r1; 
        r3 /= r2;
        r3 *= r2;
        r1 -= r3;
        r1 *= r1;
        r3 = r1; 
        r3 /= r2;
        r3 *= r2;
        r1 -= r3;
        r3 = r4; 
        r3 /= r2;
        r3 *= r2;
        r4 -= r3;
        r1 *= r1;
        r3 = r1; 
        r3 /= r2;
        r3 *= r2;
        r1 -= r3;
        r1 *= r1;
        r3 = r1; 
        r3 /= r2;
        r3 *= r2;
        r1 -= r3;
        r1 *= r1;
        r3 = r1; 
        r3 /= r2;
        r3 *= r2;
        r1 -= r3;
        r1 *= r1;
        r3 = r1; 
        r3 /= r2;
        r3 *= r2;
        r1 -= r3;
        r1 *= r1;
        r3 = r1; 
        r3 /= r2;
        r3 *= r2;
        r1 -= r3;
        r1 *= r1;
        r3 = r1; 
        r3 /= r2;
        r3 *= r2;
        r1 -= r3;
        r1 *= r4;
        r3 = r1; 
        r3 /= r2;
        r3 *= r2;
        r1 -= r3;
        if (r1 == expected)
            printf("%d: found 0x%lx\n", idx, i);
    }

}

void main(void)
{
#if 0
1: found 0x41bfa3fb
1: found 0xcc064928
2: found 0x93865b44
#endif

    find(1, 0x8a46a52d, 0x204c4c41);
    find(2, 0xdc6c88e1, 0x37313032);
}
